
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>


#include "cgdk.h"
#include "dpmi.h"
#include "file.h"
#include "car.h"
#include "keyb.h"
#include "svga.h"
#include "dith.h"
#include "mouse.h"
#include "scroll.h"
#include "timer.h"
#include "joy.h"

#include "cmm_.cpp"

#define CGDK_VERSION "0.76"

#ifdef CGDK_TRIAL
  #define CGDK_VERSION_S CGDK_VERSION" trial"
#else
  #define CGDK_VERSION_S CGDK_VERSION" full"
#endif

/*#define CGDK_DATE "The used version of the Cybertek Game Develompent Kit was compiled on\n"
                  "__DATE__" at "__TIME__".\n"*/

#define CGDK_COPYRIGHT \
"This program uses Cybertek Game Development Kit, version "CGDK_VERSION_S".\n"\
"Cybertek Game Development Kit is provided \"as is\", without any warranty.\n"\
"Cybertek Game Development Kit is a trademark of Cybertek and is\n"\
"Copyright (C) by Marek Gayer - Cybertek 1994-1997. All rights reserved.\n"\
"\n"\
"Contact Cybertek on the Internet - e-mail: xgayer@fel.cvut.cz\n"



#ifdef __TURBOC__
  #define ERROR_STR_SIZE 256
#else
  #define ERROR_STR_SIZE 2048
#endif

#define ATEXIT_FNMAX 32

//long CGDK_fp;
int CGDK_debug;
char exitStr [ERROR_STR_SIZE]="";

const char CGDK_copyright [] = CGDK_COPYRIGHT;

const char CGDK_version [] = CGDK_VERSION;
const char CGDK_date [] = __DATE__;
const char CGDK_time [] = __TIME__;

int sign (int x)
{
  if (x)
    return 1- 2*(x < 0);
  else
    return 0;
}

int resetBit (int number, int Bit)
{
  return number & ((1 << Bit) ^ -1);
}

int setBit (int number, int Bit)
{
  return number | (1 << Bit);
}

int _div (int numer, int demon)
{
  return (numer / demon) + ((numer % demon) != 0);
}

void writeln (void)
{
  puts ("");
}

void CGDK_exit (const char *errorStr, int exitCode)
{
  _cexit ();
  printf (errorStr);
  exit (exitCode);
}

void CGDK_exitTrial (void)
{
  CGDK_exit ("This feature is not supported in the trial version of the CGDK.\n", EXIT_FAILURE);
}

void CGDK_abort (const char *errorStr)
{
  _cexit ();
  printf (errorStr);
  abort ();
}

char CGDK_path [_MAX_PATH];
char CGDK_drive[_MAX_DRIVE];
char CGDK_dir[_MAX_DIR];
char CGDK_file[_MAX_FNAME];
char CGDK_ext[_MAX_EXT];

char *CGDK_getProgramPath (char *fileName)
{

  if (fileName != NULL)
  {
    _splitpath (_argv [0], CGDK_drive, CGDK_dir, CGDK_file, CGDK_ext);
    _makepath (CGDK_path, CGDK_drive, CGDK_dir, fileName, NULL);
    return CGDK_path;
  }
  else
  {
    return _argv [0];
  }
}

_atexit_t _exitfn [ATEXIT_FNMAX];
int _exitfnlast;

int _atexit (_atexit_t func)
{
  int i;

  if (_exitfnlast < ATEXIT_FNMAX-1)
  {
    for (i = 0; i < _exitfnlast; i++)
    {
      if (_exitfn [i] == func)
      {
        // already registered
        return -1;
      }
    }
    _exitfn [_exitfnlast] = func;
    _exitfnlast++;
  }
  return atexit (func);
}

void _cexit (void)
{
  int i;

  i = _exitfnlast;

  while (i > 0)
  {
    i--;
    _exitfn [i] ();
  }

  _exitfnlast = 0;
}

