
#include <stdio.h>

#include "joy.h"
#include "keyb.h"
#include "cgdk.h"
#include "svga.h"
#include "tm.h"

char *statestr [] = {"Not detected",
                     "Detected    "};
char *buttonstr [] = {"Released",
                      "Pressed "};

int main (void)
{
  KEYB_init ();

  printf ("\n"
          "JOY - joystick test program\n"
          "\n%s\n",CGDK_copyright);

  CGDK_init ();

  if (JOY_init () != JOY_NOTDETECTED)
  {
    SVGA_setDefaultMode ();

    printf ("Move stick to the upper left corner and press button 1 to continue.\n");
    while (!JOY_state.a.button1)
    {
      JOY_moveUpperLeftA ();
    }
    printf ("Move stick to the lower right corner and press button 2 to continue.\n");
    while (!JOY_state.a.button2)
    {
      JOY_moveLowerRightA ();
    }

    printf ("JOY_state._Mask: %i\n", JOY_state.mask);
    printf ("Press Esc to continue.\n");

    while (!KEYB_hit (KEY_ESC))
    {
      JOY_read ();
      TM_setCursorPos (0,3);
      printf ("Joystick A                        Joystick B\n"
              "============================================\n"
              "  State : %s            %s\n"
              "Button 1: %s                %s\n"
              "Button 2: %s                %s\n"
              "  Axis X: %5i                   %5i\n"
              "  Axis Y: %5i                   %5i\n"
              "  Position: %5i\n",
              statestr [JOY_state.a.installed]          , statestr [JOY_state.b.installed],
              buttonstr [JOY_state.a.button1], buttonstr [JOY_state.b.button1],
              buttonstr [JOY_state.a.button2], buttonstr [JOY_state.b.button2],
              JOY_state.a.axisX              , JOY_state.b.axisX,
              JOY_state.a.axisY              , JOY_state.b.axisY,
              JOY_positionA ());
    }
  }
  else
  {
    CGDK_exit ("No joysticks found.\n", EXIT_FAILURE);
  }

  return JOY_state.mask;
}
