
#include <io.h>
#include <stdio.h>
#include <stdlib.h>

#include "lzw.h"

static int LZWF_inLimit;
FILE *LZWF_inFile;
FILE *LZWF_outFile;

int LZWF_init (TLZW *lzw, const char *inFile, const char *outFile)
{
  int exitCode;

  LZWF_inFile = fopen (inFile, "rb");
  if (LZWF_inFile == NULL)
  {
    exitCode = 1;
  }
  else
  {
    LZWF_outFile = fopen (outFile, "wb");
    if (LZWF_outFile == NULL)
    {
      exitCode = 2;
    }
    else
    {
      lzw->putChar = LZWF_putChar;
      lzw->getChar = LZWF_getChar;
      exitCode = 0;
    }
  }

  return exitCode;
}

int LZWF_getChar (void)
{
  return getc (LZWF_inFile);
}

int LZWF_putChar (int c)
{
  return putc (c, LZWF_outFile);
}

void LZWF_done (TLZW *lzw)
{
  if (LZWF_inFile != NULL)
  {
    fclose (LZWF_inFile);
    LZWF_inFile = NULL;
  }
  if (LZWF_outFile != NULL)
  {
    fclose (LZWF_outFile);
    LZWF_outFile = NULL;
  }

  lzw->putChar = LZW_putCharError;
  lzw->getChar = LZW_getCharError;
}
