
#ifndef _PAL_H_
  #define _PAL_H_

  #ifdef __cplusplus
  extern "C" {
  #endif


  #define PAL_6BIT 6
  #define PAL_8BIT 8

  typedef struct 
  {
    unsigned char r;
    unsigned char g;
    unsigned char b;
    unsigned char a;
  } TRGBColor;

  extern int PAL_nearestColor ( TRGBColor color,  TRGBColor *pal, int palLen);
  extern void PAL_colorFadeStep ( TRGBColor *newColor,  TRGBColor startColor,  TRGBColor endColor,
                                int stepCur, int stepMax);

  extern int PAL_findColor ( TRGBColor color,  TRGBColor *pal,
			    int palLen); // = 256

  extern int PAL_insertColor ( TRGBColor color,  TRGBColor *pal,
			      int pallen); // = 256

  extern int PAL_deleteColor ( TRGBColor color,  TRGBColor *pal,
			      int pallen); // = 256

  extern int PAL_countColors ( TRGBColor *pal,
			      int palLen); // = 256

//  extern int PAL_findFreeColorBlock (int blockLen,  TRGBColor *pal,
//                                   int palLen = 256);


  extern void PAL_countFadeStep ( TRGBColor *startPal,  TRGBColor *endPal,
				 int stepCur, int stepMax,  TRGBColor *fadePal,
				 int maxColor); // = 256


  extern void PAL_set ( TRGBColor *Pal,
		      int StartColor, int NumColors); // = 0, = 256
  extern void PAL_get ( TRGBColor *Pal,
		      int StartColor, int NumColors); // = 0, = 256
  extern void PAL_clear (int StartColor, int NumColors); // = 0, = 256

  extern void PAL_mix ( TRGBColor *startPal,  TRGBColor *endPal,
		       int stepMax,
		       int baseColor, int maxColor); // = 0, = 256

  extern void PAL_fadeIn ( TRGBColor *pal, int stepMax,
			  int baseColor, int maxColor); // = 100, = 0, = 256

  extern void PAL_fadeOut ( TRGBColor *pal, int stepMax,
			   int baseColor, int maxColor); // = 100, = 0, = 256

  extern void PAL_fadeAway ( TRGBColor *pal, int stepMax,
			   int baseColor, int maxColor);

  extern void PAL_setDefault (void);

  extern void PAL_PAL2RGB (TRGBColor *RGBPAL, char *Pal, int maxColor);  // = 256

  extern void PAL_rotateGreen (TRGBColor *pal, int count);  // = 256
  extern void PAL_rotateRed (TRGBColor *pal, int count);  // = 256
  extern void PAL_rotateBlue (TRGBColor *pal, int count);  // = 256
  extern void PAL_mirrorRed (TRGBColor *pal, int count);  // = 256
  extern void PAL_mirrorGreen (TRGBColor *pal, int count);  // = 256
  extern void PAL_mirrorBlue (TRGBColor *pal, int count);  // = 256

  #ifdef __cplusplus
  }
  #endif

#endif
