

#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>
#include <conio.h>

#include "file.h"
#include "cgdk.h"
#include "dig.h"
#include "mouse.h"
#include "svga.h"
#include "keyb.h"
#include "win.h"
#include "tm.h"
#include "pak.h"

#include "mikmod.h"
//#include "mtypes.h"
//#include "mdriver.h"    // -> MD_Init,MD_Exit etc.
//#include "mwav.h"               // -> MW_LoadWavFN & MW_FreeWav
//#include "mems.h"               // -> EMS_Init
//#include "vtimer.h"

#define SAMPLE_LEN 75

//#define VIDEO_40x25
//#define VIDEO_MODE VESA_640x400x256
//#define VIDEO_MODE XVGA_320x240x256

#ifdef __TURBOC__
  #define VIEWER_LINES 25
#else
  #define VIEWER_LINES 1000
#endif

extern DRIVER gusdriver,sbdriver;
int vtimer;
long ticks;

int breakhandler(void)
{
  return 1;
}



void tickhandler(void)
{
  ticks++;
  MD_Update();
}


char *MyDefaultMiniHelp [] =
{"~Arrows keys~=select item  ~Enter~=confirm select  ~Esc~=abort select\n",
NULL};


TWIN *MyDesktop;
TWIN *MyWinMiniHelp;
TWIN *MyWinMiniStatus;

TWIN *WinError;
TWIN *WinPlaying;
TWIN *WinViewer;
TWIN *WinAbout;
TWIN *WinDesc;
TWIN *WinMain;
TWIN *WinStatus;
TWIN *WinSelectDevice;
TWIN *WinSaveOptions;

TWIN *WinSetSBPort;
TWIN *WinSetSBIRQ;
TWIN *WinSetSBDMA;
TWIN *WinSetSB16DMA;

TWIN *WinSetGUSPort;
TWIN *WinSetGUSIRQ;
TWIN *WinSetGUSDMA;

TWINItem *type,*port,*dma,*irq,*dma16;

#define CONFIG_FILENAME "setup.cfg"

TOptions Options = {S_NOSOUND, S__NOSOUND,
                    S_NONE, S__NONE,
                    S_NONE, S__NONE,
                    S_NONE, S__NONE};


void loadOptions (void)
{
  if (F_load (CONFIG_FILENAME, (void *) &Options, sizeof Options, 0))
  {
    Options. s_type = S_NOSOUND;
    strcpy (Options.s_typeStr, S__NOSOUND);
    Options. s_port = S_NONE;
    strcpy (Options.s_portStr, S__NONE);
    Options. s_irq = S_NONE;
    strcpy (Options.s_irqStr, S__NONE);
    Options. s_dma = S_NONE;
    strcpy (Options.s_dmaStr, S__NONE);
    Options. s_dma16 = S_NONE;
    strcpy (Options.s_dma16Str, S__NONE);

  }
}

void saveOptions (void)
{
  Options.s_type = type->value;
  Options.s_port = port->value;
  Options.s_irq  = irq->value;
  Options.s_dma = dma->value;
  Options.s_dma16 = dma16->value;
  strcpy (Options.s_typeStr, type->item);
  strcpy (Options.s_portStr, port->item);
  strcpy (Options.s_irqStr, irq->item);
  strcpy (Options.s_dmaStr, dma->item);
  strcpy (Options.s_dma16Str, dma16->item);

  F_save (CONFIG_FILENAME, (void *) &Options, sizeof Options);
}

void setupStatusWin (void)
{
  WIN_deleteContent (WinStatus);
  WIN_appendComment (WinStatus);
  type = WIN_item (WinStatus, WIN_appendButton (WinStatus,
                   " Sound Card Type       :", Options.s_typeStr, Options.s_type));
  port = WIN_item (WinStatus, WIN_appendButton (WinStatus,
                   " Sound Card Port       :", Options.s_portStr, Options.s_port));
  irq  = WIN_item (WinStatus, WIN_appendButton (WinStatus,
                   " Sound Card IRQ        :", Options.s_irqStr, Options.s_irq));
  dma  = WIN_item (WinStatus, WIN_appendButton (WinStatus,
                   " Sound Card DMA        :", Options.s_dmaStr, Options.s_dma));
  dma16 = WIN_item (WinStatus, WIN_appendButton (WinStatus,
                   " Sound Card 16-bit DMA :", Options.s_dma16Str, Options.s_dma16));
}

void selectGUS (void)
{
  port->value = S_AUTODETECT;
  strcpy (port->item, S__AUTODETECT);
  dma->value  = S_AUTODETECT;
  strcpy (dma->item, S__AUTODETECT);
  dma16->value  = S_AUTODETECT;
  strcpy (dma16->item, S__AUTODETECT);
  irq->value  = S_AUTODETECT;
  strcpy (irq->item, S__AUTODETECT);
}


void selectNoneDevice (void)
{
  port->value = S_NONE;
  strcpy (port->item, S__NONE);
  dma->value  = S_NONE;
  strcpy (dma->item, S__NONE);
  irq->value  = S_NONE;
  strcpy (irq->item, S__NONE);
  dma16->value  = S_NONE;
  strcpy (dma16->item, S__NONE);
}


void MIKMOD_init (void)
{
  /*
          Register the drivers we want to use:
  */

  MD_RegisterDriver(&sbdriver);
  MD_RegisterDriver(&gusdriver);

  /*
          disable control-break by
          installing a custom handler
  */

#ifdef __BORLANDC__
  ctrlbrk(breakhandler);
  EMS_Init();
#endif
}

void SetupError (int errnum, char *errstr)
{
  #define ERRORSPACE "   "
  char estr [WIN_ITEMLEN];
  strcpy (estr, ERRORSPACE);
  strcat (estr, errstr);

  WIN_deleteContent (WinError);
  WIN_insertItem (WinError);
  WIN_appendComment (WinError, ERRORSPACE"An error has occured.");
  WIN_appendComment(WinError);
  WIN_appendComment(WinError, estr);
  WIN_appendComment(WinError);
  WIN_appendComment(WinError);
  WIN_appendComment(WinError, ERRORSPACE"< Press Escape to continue >");
  WIN_appendComment(WinError);
  WIN_exec (WinError);
}


void autoDetect (void)
{
  md_device = 0; // standard device: autodetect

  if (MD_Init (MD_AUTODETECT))
  {
    switch (md_device)
    {
      case MD_GUS:
      {
        // gus detected
        type->value = S_ULTRASOUND;
        strcpy (type->item, S__ULTRASOUND);
        selectGUS ();
        break;
      }
      case MD_SB:
      {
        type->value = S_SOUNDBLASTER;
        strcpy (type->item, S__SOUNDBLASTER);
        dma16->value  = S_NONE;
        strcpy (dma16->item, S__NONE);

        if (sb_ver > VER_SBPRO)
        {
          type->value = S_SOUNDBLASTER_PRO;
          strcpy (type->item, S__SOUNDBLASTER_PRO);
        }

        if (sb_ver > VER_SB16)
        {
          type->value = S_SOUNDBLASTER_16;
          strcpy (type->item, S__SOUNDBLASTER_16);
          dma16->value  = sb_hidma;
          sprintf (dma16->item, " %i",sb_hidma);
        }

        port->value = sb_port;
        sprintf (port->item, " %03xh",sb_port);
        dma->value  = sb_lodma;
        sprintf (dma->item, " %i",sb_lodma);
        irq->value  = sb_irq;
        sprintf (irq->item, " %i",sb_irq);
        break;
      }
    }

    MD_Exit ();
  }
  else
  {
    type->value = S_NOSOUND;
    strcpy (type->item, S__NOSOUND);
    selectNoneDevice ();
  }
  WIN_show (WinStatus);
}

void select (void)
{
  int Command;

  WIN_open (WinSelectDevice);
  Command = WIN_insert (WinSelectDevice);

  if (Command != WIN_COM_ESC)
  {
    selectNoneDevice ();
    WIN_show (WinStatus);

    switch (WIN_value (WinSelectDevice))
    {
      case S_ULTRASOUND:
      {
        selectGUS ();
        WIN_show (WinStatus);
        break;
      }
      case S_PROAUDIO_PLUS:
      case S_PROAUDIO_16:
      {
        WIN_exec (WinSetSBPort);
        break;
      }
      case S_SOUNDBLASTER:
      case S_SOUNDBLASTER_PRO:
      {
        WIN_exec (WinSetSBPort);
        WIN_exec (WinSetSBIRQ);
        WIN_exec (WinSetSBDMA);
        break;
      }
      case S_SOUNDBLASTER_16:
      {
        WIN_exec (WinSetSBPort);
        WIN_exec (WinSetSBIRQ);
        WIN_exec (WinSetSBDMA);
        WIN_exec (WinSetSB16DMA);
        break;
      }
      case S_NOSOUND:
      {
        break;
      }
    }
  }
  WIN_close (WinSelectDevice);
}


/*
void InitWasOkay(void)
{

        int t;
        SAMPLE *s1,*s2;

        if((s1=MW_LoadWavFN("b1.wav"))==NULL){
                printf("Wavload error: %s.\n",myerr);
                return;
        }

        if((s2=MW_LoadWavFN("b2.wav"))==NULL){
                printf("Wavload error: %s.\n",myerr);
                MW_FreeWav(s1);
                return;
        }

        md_numchn=32;

        VT_Init();
        atexit(VT_Exit);

        vtimer=VT_Alloc();
        VT_SetHandler(vtimer,tickhandler);
        VT_SetBPM(vtimer,125);

        MD_PlayStart();

        VT_Start(vtimer);

        while(1){

                t=KEYB_ascii (KEYB_wait ());

                if(t=='q') break;

                if(t=='1'){
                        MD_VoiceSetVolume(0,64);
                        MD_VoiceSetPanning(0,0);
                        MD_VoiceSetFrequency(0,12000);
                        MD_VoicePlay(0,s1->handle,0,s1->length,0,0,s1->flags);
                }

                if(t=='2'){
                        MD_VoiceSetVolume(1,64);
                        MD_VoiceSetPanning(1,64);
                        MD_VoiceSetFrequency(1,13000);
                        MD_VoicePlay(1,s1->handle,0,s1->length,0,0,s1->flags);
                }

                if(t=='3'){
                        MD_VoiceSetVolume(2,64);
                        MD_VoiceSetPanning(2,128);
                        MD_VoiceSetFrequency(2,10000);
                        MD_VoicePlay(2,s2->handle,0,s2->length,0,0,s2->flags);
                }

                if(t=='5'){
                        MD_VoiceSetVolume(5,64);
                        MD_VoiceSetPanning(5,200);
                        MD_VoiceSetFrequency(5,12000);
                        MD_VoicePlay(5,s2->handle,0,s2->length,0,0,s2->flags);
                }

                if(t=='4'){
                        MD_VoiceSetVolume(4,64);
                        MD_VoiceSetPanning(4,200);
                        MD_VoiceSetFrequency(4,12000);
                        MD_VoicePlay(4,s2->handle,0,s2->length,0,0,s2->flags);
                }
        }

        VT_Stop(vtimer);
        VT_Free (vtimer);
        MD_PlayStop();
        MW_FreeWav(s1);
        MW_FreeWav(s2);


}
*/

void test (void)
{
  SAMPLE *sample;
  /*
          Initialize soundcard parameters.. you _have_ to do this
          before calling MD_Init(), and it's illegal to change them
          after you've called MD_Init()
  */

  md_mixfreq      =44100;                         // standard mixing freq
  md_dmabufsize   =4000;                          // standard dma buf size
  md_mode         =DMODE_16BITS|DMODE_STEREO;     // standard mixing mode
  switch (type->value)
  {
    case S_PROAUDIO_PLUS:
    case S_PROAUDIO_16:
    case S_NOSOUND:
    {
      md_device = MD_NONE;
      break;
    }
    case S_ULTRASOUND:
    {
      md_device = MD_GUS;
      break;
    }
    case S_SOUNDBLASTER:
    {
      md_device = MD_SB;
      sb_port = port->value;
      sb_irq = irq->value;
      sb_lodma = dma->value;
      sb_ver = VER_SB;
      break;
    }
    case S_SOUNDBLASTER_PRO:
    {
      md_device = MD_SB;
      sb_port = port->value;
      sb_irq = irq->value;
      sb_lodma = dma->value;
      sb_ver = VER_SBPRO;
      break;
    }
    case S_SOUNDBLASTER_16:
    {
      md_device = MD_SB;
      sb_port = port->value;
      sb_irq = irq->value;
      sb_lodma = dma->value;
      sb_hidma = dma16->value;
      sb_ver = VER_SB16;
      break;
    }
  }

  if (md_device != MD_NONE)
  {
    if (MD_Init (MD_MANUAL))
    {

 //     InitWasOkay ();

      if((sample=MW_LoadWavFN("setup.wav"))==NULL)
      {
        SetupError (3,"Error loading digital sample setup.wav");
      }
      else
      {
        md_numchn=32;

        VT_Init();
        atexit(VT_Exit);

        ticks=0;
        vtimer=VT_Alloc();
        VT_SetHandler(vtimer,tickhandler);
        VT_SetBPM(vtimer,125);

        MD_PlayStart();

        VT_Start(vtimer);

        MD_VoiceSetVolume(0,127);
        MD_VoiceSetPanning(0,128);
        MD_VoiceSetFrequency(0,22050);

        WIN_openActive (WinPlaying);
        WIN_redrawScreen ();

        MD_VoicePlay(0,sample->handle,0,sample->length,0,0,sample->flags);

        while ((ticks < SAMPLE_LEN) && (KEYB_get () != KEY_ESC))
          ;

        WIN_close (WinPlaying);
        WIN_redrawScreen ();

        VT_Stop(vtimer);
        VT_Free (vtimer);
        MD_PlayStop();

        MW_FreeWav(sample);
      }
      MD_Exit ();
    }
    else
    {
      SetupError (1,"Sound device initialization failed");
    }
  }
  else
  {
    SetupError (2, "To test your sound device, please select it first");
  }
}




int main (void)
{
  int Command;
  TWINItem *item;
  TCSF *spr = NULL;
  int pakHandle;
  TRGBColor pal [256] = {0};

  if (SVGA_compatible)
  {
    #ifdef VIDEO_40x25
      SVGA_setVideoMode (0);
    #else
      SVGA_setVideoMode (3);
    #endif

    #ifdef VIDEO_MODE
    if (SVGA_compatible & VESA_COMPATIBLE)
    {
      pakHandle = PAK_open (PAK_FILESPEC_EMU);
      spr = CSF_new (pakHandle, "desktop.csf");
      SVGA_setVideoMode (VIDEO_MODE);
      SVGA_clear (0);
      TM_font = CSF_new (pakHandle, "scifi.csf");
      CSF_updateColors (TM_font, pal);
      CSF_updateColors (spr, pal);
      PAL_set (pal);
    }
    else
    {
      CGDK_exit ("VESA compatible videocard required.\n");
    }
    #endif

    MIKMOD_init ();
    MD_Init (1);

    loadOptions ();

    if (WIN_init () == 0)
    {
      WIN_setDefaultMiniHelp (MyDefaultMiniHelp);

      WIN_setDesktop ('', 31, spr);

      WinAbout = WIN_new (2);
      WIN_setBounds (WinAbout, 1, 1, TM_length-4, 4);
      WIN_setColors (WinAbout, 49);
      WIN_appendComment (WinAbout, " Cybertek Setup Version 0.3");
      WIN_appendComment (WinAbout, " Copyright (C) 1995 Action Excel Inc.");
      WIN_openPassive (WinAbout);
      WIN_redrawScreen ();

      MyWinMiniStatus = WIN_new ();
      WIN_setNoneFrame (MyWinMiniStatus);
      WIN_setBounds (MyWinMiniStatus, 0, 22, 80, 2);
      WIN_setColors (MyWinMiniStatus, 7);
      WIN_setMiniStatusWin (MyWinMiniStatus);

      MyWinMiniHelp = WIN_new ();
      WIN_setNoneFrame (MyWinMiniHelp);
      WIN_setBounds (MyWinMiniHelp, 0, 24, 80, 1);
      WIN_setColors (MyWinMiniHelp, 112, 112, 113);
      WIN_setMiniHelpWin (MyWinMiniHelp);

      WinError = WIN_new (10);
      WIN_setBounds (WinError, -1, -1, 60, 10);
      WIN_setColors (WinError,WHITE + B_RED);
      WinError->commsAvail.enter = 0;
      WinError->commsAvail.f10 = 0;

      WinPlaying = WIN_new (10);
      WIN_setBounds (WinPlaying, -1, -1, 40, 7);
      WIN_setColors (WinPlaying,WHITE + B_GREEN);
      WinPlaying->commsAvail.enter = 0;
      WinPlaying->commsAvail.f10 = 0;
      WIN_appendComment (WinPlaying);
      WIN_appendComment (WinPlaying," Playing digital sound ...");
      WIN_appendComment (WinPlaying);
      WIN_appendComment (WinPlaying," Press <Escape> to abort");

      WinViewer = WIN_new (VIEWER_LINES);
      WIN_scrollBarEnable (WinViewer);
      WIN_setBounds (WinViewer, 0, 1, 78, 20);
      WIN_setColors (WinViewer, 31, 127);
      WinViewer->color.frameSelect = 23;
      WIN_setTitle (WinViewer, " The Readme File ");
      WIN_setSpr (WinViewer, spr);
      WIN_newViewer (WinViewer, "README.TXT",
                                "Use Arrow Keys, Page Up, Page Down, Home, End to display more\n"
                                "Enter or Esc to quit");


      WinMain = WIN_new (10);
      WIN_scrollBarEnable (WinMain);
      WIN_setBounds (WinMain,  1, 7, 27, 8);
      WIN_setColors (WinMain, 79, 127);
      WinMain->color.h_barSelect = 112;
      WIN_setTitle (WinMain, " Setup Menu");

      WIN_appendButton (WinMain, "", " Autodetect Sound Card\n", -1,
                            "Autodetection of music and sound device\n\n");
                            //, WIN_iTEMT_INPUT, 20);

      WIN_appendButton (WinMain, "", " Select Sound Card\n", -1,
                            "Sound and music device selection\n");

      WIN_appendButton (WinMain, "", " Test Sound Card\n", -1,
                            "Test of currently selected sound device\n");

      WIN_appendButton (WinMain, ""," View the README file\n", -1,
                            "View manual addendum and updates\n\n");
      WIN_appendComment (WinMain, "");

      WIN_appendButton (WinMain, "", " Exit\n", -1,
                            "Save settings and exit\n");

      /*
      WIN_appendCheckBox (WinMain, "Double Buffering ", "On\x0Off");
      item = WIN_item (WinMain,WIN_appendItem (WinMain, WIN_ITEMT_SCROLLBAR,
                       "Adjust :", "<========>", -1, "just adjust"));
      item->maxLen = 60;
      item->step = 10;
      */


      WinSaveOptions = WIN_new (10);
      WIN_scrollBarEnable (WinSaveOptions);
      WIN_setBounds (WinSaveOptions, 9, 13, 20, 5);
      WIN_setColors (WinSaveOptions, 79, 127);
      WIN_setTitle (WinSaveOptions, " Save Options ? ");
      WIN_appendButton (WinSaveOptions, "", " Yes\n", -1,
                                       "Save options and exit\n");

      WIN_appendButton (WinSaveOptions, ""," No\n", -1,
                                      "Do not save options and exit\n");

      WIN_appendButton (WinSaveOptions, ""," Cancel\n", -1,
                                      "Cancel exit and return to main menu\n");

      WinSelectDevice = WIN_new (10);
      WIN_scrollBarEnable (WinSelectDevice);
      WIN_setBounds (WinSelectDevice, 22, 10, 29, 7);
      WIN_setColors (WinSelectDevice, 79, 127);
      WIN_setTitle (WinSelectDevice, " Available Sound Cards ");
      WIN_appendButton (WinSelectDevice, "",
                      S__ULTRASOUND, S_ULTRASOUND,
                      "Advanced Gravis Ultrasound\n");
      /*
      WIN_appendButton (WinSelectDevice, "",
                      S__PROAUDIO_16, S_PROAUDIO_16,
                      "Media Vision Pro Audio Spectrum Plus\n");
      WIN_appendButton (WinSelectDevice, "",
                      S__PROAUDIO_PLUS,S_PROAUDIO_PLUS,
                      "Media Vision Pro Audio Spectrum 16\n");
      */
      WIN_appendButton (WinSelectDevice, "",
                      S__SOUNDBLASTER, S_SOUNDBLASTER,
                      "Creative Labs Sound Blaster 1.0, 1.5, 2.0 or compatible\n");
      WIN_appendButton (WinSelectDevice, "",
                      S__SOUNDBLASTER_PRO, S_SOUNDBLASTER_PRO,
                      "Creative Labs Sound Blaster Pro or compatible\n");
      WIN_appendButton (WinSelectDevice, "",
                      S__SOUNDBLASTER_16, S_SOUNDBLASTER_16,
                      "Creative Labs Sound Blaster 16 or compatible\n");
      WIN_appendButton (WinSelectDevice, "",
                      S__NOSOUND, S_NOSOUND,
                      "No sound device\n");

      WinStatus = WIN_new (10);
      WIN_setBounds (WinStatus, 32, 7, 45, 8);
      WIN_setColors (WinStatus, 95);
      WIN_setTitle (WinStatus, " The Status ");

      setupStatusWin ();

      WIN_openPassive (WinStatus);
      WIN_setHumble (WinSelectDevice, WinStatus, 1);

      WinSetSBPort = WIN_new (10);
       WIN_setBounds (WinSetSBPort, 49, 9, 17, 9);
      WIN_setColors (WinSetSBPort, 79, 127);
      WIN_setTitle (WinSetSBPort, " Select Port ");
      WIN_appendButton (WinSetSBPort, "", " 210h\n", 0x210);
      WIN_appendButton (WinSetSBPort, "", " 220h\n", 0x220);
      WIN_appendButton (WinSetSBPort, "", " 230h\n", 0x230);
      WIN_appendButton (WinSetSBPort, "", " 240h\n", 0x240);
      WIN_appendButton (WinSetSBPort, "", " 250h\n", 0x250);
      WIN_appendButton (WinSetSBPort, "", " 260h\n", 0x260);
      WIN_appendButton (WinSetSBPort, "", " 280h\n", 0x280);
      WinSetSBPort->commsAvail.esc = 0;
      WIN_setHumble (WinSetSBPort, WinStatus, 2);

      WinSetSBIRQ = WIN_new (10);
      WIN_setBounds (WinSetSBIRQ, 49, 9, 16, 6);
      WIN_setColors (WinSetSBIRQ, 79, 127);
      WIN_setTitle (WinSetSBIRQ, " Select IRQ ");
      WIN_appendButton (WinSetSBIRQ, "", " 2\n", 2);
      WIN_appendButton (WinSetSBIRQ, "", " 3\n", 3);
      WIN_appendButton (WinSetSBIRQ, "", " 5\n", 5);
      WIN_appendButton (WinSetSBIRQ, "", " 7\n", 7);
      WinSetSBIRQ->commsAvail.esc = 0;
      WIN_setHumble (WinSetSBIRQ, WinStatus, 3);

      WinSetSBDMA = WIN_new (10);
      WIN_setBounds (WinSetSBDMA, 49, 9, 16, 4);
      WIN_setColors (WinSetSBDMA, 79, 127);
      WIN_setTitle (WinSetSBDMA, " Select DMA ");
      WIN_appendButton (WinSetSBDMA, "", " 0\n", 0);
      WIN_appendButton (WinSetSBDMA, "", " 1\n", 1);
      WinSetSBDMA->commsAvail.esc = 0;
      WIN_setHumble (WinSetSBDMA, WinStatus, 4);

      WinSetSB16DMA = WIN_new (10);
      WIN_setBounds (WinSetSB16DMA, 49, 9, 22, 4);
      WIN_setColors (WinSetSB16DMA, 79, 127);
      WIN_setTitle (WinSetSB16DMA, " Select 16-bit DMA ");
      WIN_appendButton (WinSetSB16DMA, "", " 0\n", 0);
      WIN_appendButton (WinSetSB16DMA, "", " 1\n", 1);
      WinSetSB16DMA->commsAvail.esc = 0;
      WIN_setHumble (WinSetSB16DMA, WinStatus, 5);

      WinSetGUSIRQ = WIN_new (10);
      WIN_setBounds (WinSetGUSIRQ, 49, 9, 16, 6);
      WIN_setColors (WinSetGUSIRQ, 79, 127);
      WIN_setTitle (WinSetGUSIRQ, " Select IRQ ");
      WIN_appendButton (WinSetGUSIRQ, "", " 2\n", 2);
      WIN_appendButton (WinSetGUSIRQ, "", " 3\n", 3);
      WIN_appendButton (WinSetGUSIRQ, "", " 5\n", 5);
      WIN_appendButton (WinSetGUSIRQ, "", " 7\n", 7);
      WIN_appendButton (WinSetGUSIRQ, "", " 11\n", 11);
      WIN_appendButton (WinSetGUSIRQ, "", " 12\n", 12);
      WIN_appendButton (WinSetGUSIRQ, "", " 15\n", 15);
      WinSetGUSIRQ->commsAvail.esc = 0;
      WIN_setHumble (WinSetGUSIRQ, WinStatus, 3);

      WinSetGUSDMA = WIN_new (10);
      WIN_setBounds (WinSetGUSDMA, 49, 9, 16, 4);
      WIN_setColors (WinSetGUSDMA, 79, 127);
      WIN_setTitle (WinSetGUSDMA, " Select DMA ");
      WIN_appendButton (WinSetGUSDMA, "", " 0\n", 0);
      WIN_appendButton (WinSetGUSDMA, "", " 1\n", 1);
      WIN_appendButton (WinSetGUSDMA, "", " 3\n", 3);
      WIN_appendButton (WinSetGUSDMA, "", " 5\n", 5);
      WIN_appendButton (WinSetGUSDMA, "", " 6\n", 6);
      WIN_appendButton (WinSetGUSDMA, "", " 7\n", 7);
      WinSetGUSDMA->commsAvail.esc = 0;
      WIN_setHumble (WinSetGUSDMA, WinStatus, 4);


      WIN_open (WinMain);

      MainMenu:

      Command = WIN_insert (WinMain);

      if (Command == WIN_COM_ESC)
      {
        goto Exit;
      }

      switch (WinMain->contentCur)
      {
        case 0:
        {
          autoDetect ();
          break;
        }

        case 1:
        {
          select ();
          break;
        }

        case 2:
        {
          test ();
          break;
        }
        case 3:
        {
          WIN_exec (WinViewer);
          break;
        }
        case 5:
        {
          goto Exit;
        }
      }
      goto MainMenu;

      Exit:

      if (WIN_exec (WinSaveOptions) == WIN_COM_ESC)
        goto MainMenu;

      switch (WinSaveOptions->contentCur)
      {
        case 0:
          saveOptions ();
          break;
        case 1:
          break;
        case 2:
          goto MainMenu;
      }

      WIN_deleteContent (WinViewer);
      WIN_delete (WinViewer);
      WIN_done ();
    }
    else
    {
      CGDK_exit ("Unsupported video mode.\n");
    }
  }

  SVGA_done ();

  return 0;
}
